//-----------------------------------------------------------------------------------------
//File Name:UniDAQ.cs
//Update date:2014/05/14 by Dan Huang
//Support Language: Visual C#.NET 
//UniDAQ SDK User Manual: http://ftp.icpdas.com/pub/cd/iocard/pci/napdos/pci/unidaq/manual/
//--------------------
//-----------------------------------------------------------------------------------------
//File Name:PCIELM4.cs
//Update date:2020/01/17 by Mike Chou
//Support Language: Visual C#.NET 
//--------------------


using System.Runtime.InteropServices;

using System;
//using System.Collections;
using System.Collections.Generic;
using System.Text;
//using System.Data;
//using System.Drawing;
//using System.Diagnostics;
//using System.Windows.Forms;


namespace PCIELM4_Ns
{
    public class PCIELM4_DLL
    {
        public const uint MAX_BOARD_NUMBER =    32;
        public const uint MAX_EVENT_NUMBER =    20;
        public const uint MAX_AO_CHANNEL =      32;

        //Option Mode
        public const uint MULTIPROCESSOR =  1;
        public const uint ENABLEMEMIO =     2;
        public const uint ENABLEDMAAI =     16;

        //ModelNumber
        public const UInt32 PCIELM4 = 0xD61E39;

        public const uint MAX_CFGCODE_NUMBER =  4;

        //User Analog Input Config Code

        public const UInt16 PCIELM4_AI_BI_10V = 0;      //Bipolar +/- 10V
        public const UInt16 PCIELM4_AI_BI_5V = 1;       //Bipolar +/-  5V
        public const UInt16 PCIELM4_AI_BI_2V5 = 2;      //Bipolar +/-  2.5V
        public const UInt16 PCIELM4_AI_BI_1V25 = 3;     //Bipolar +/-  1.25V
        public const UInt16 PCIELM4_AI_BI_227MV = 0;       //Bipolar +/-  227 mV

        //AI Sampling Rate
        public const UInt16 PCIELM4_AIRATE_15000 = 15000;
        public const UInt16 PCIELM4_AIRATE_7500 =     7500;
        public const UInt16 PCIELM4_AIRATE_3750 =     3750;
        public const UInt16 PCIELM4_AIRATE_1000 =     1000;
        public const UInt16 PCIELM4_AIRATE_500 =      500;
        public const UInt16 PCIELM4_AIRATE_30 =       30;
        public const UInt16 PCIELM4_AIRATE_15 =       15;


        //User Analog Output Config Code for Voltage
        public const UInt16 PCIELM4_AO_UNI_5V =   0;       //Unipolar 0  ~  5 V
        public const UInt16 PCIELM4_AO_UNI_10V =  1;     //Unipolar 0  ~ 10 V
        public const UInt16 PCIELM4_AO_BI_5V =    2;       //Bipolar  +/-   5 V
        public const UInt16 PCIELM4_AO_BI_10V =   3;      //Bipolar +/-  10 V
        public const UInt16 PCIELM4_AO_BI_227MV = 0;      //Bipolar +/-  227 mV



        // Return code
        public const UInt16 PCIELM4_NoErr =                   0;  //Correct
        public const UInt16 PCIELM4_OpenDriverErr =           1;  //Open driver error
        public const UInt16 PCIELM4_PnPDriverErr =            2;  //Plug & Play error
        public const UInt16 PCIELM4_DriverNoOpen =            3;  //The driver was not open
        public const UInt16 PCIELM4_GetDriverVersionErr =     4;  //Recieve driver version error
        public const UInt16 PCIELM4_ExceedBoardNumber =       5;  //Board number error
        public const UInt16 PCIELM4_FindBoardErr =            6;  //No board found
        public const UInt16 PCIELM4_BoardMappingErr =         7;  //Board Mapping error
        public const UInt16 PCIELM4_DIOModesErr =             8;  //Digital input/output mode setting error
        public const UInt16 PCIELM4_InvalidAddress =          9;   //Invalid address
        public const UInt16 PCIELM4_InvalidSize =             10;   //Invalid size
        public const UInt16 PCIELM4_InvalidPortNumber =       11;   //Invalid port number
        public const UInt16 PCIELM4_UnSupportedModel =        12;   //This board model is not supported
        public const UInt16 PCIELM4_UnSupportedFun =          13;   //This function is not supported
        public const UInt16 PCIELM4_InvalidChannelNumber =    14;   //Invalid channel number
        public const UInt16 PCIELM4_InvalidValue =            15;   //Invalid value
        public const UInt16 PCIELM4_InvalidMode =             16;   //Invalid mode
        public const UInt16 PCIELM4_GetAIStatusTimeOut =      17;   //A timeout occurred while receiving the status of the analog input
        public const UInt16 PCIELM4_TimeOutErr =              18;   //Timeout error
        public const UInt16 PCIELM4_CfgCodeIndexErr =         19;   //A compatible configuration code table index could not be found
        public const UInt16 PCIELM4_ADCCTLTimeoutErr =        20;   //ADC controller a timeout error
        public const UInt16 PCIELM4_FindPCIIndexErr =         21;   //A compatible PCI table index value could not be found
        public const UInt16 PCIELM4_InvalidSetting =          22;   //Invalid setting value
        public const UInt16 PCIELM4_AllocateMemErr =          23;   //Error while allocating the memory space
        public const UInt16 PCIELM4_InstallEventErr =         24;   //Error while installing the interrupt event
        public const UInt16 PCIELM4_InstallIrqErr =           25;   //Error while installing the interrupt IRQ
        public const UInt16 PCIELM4_RemoveIrqErr =            26;   //Error while removing the interrupt IRQ
        public const UInt16 PCIELM4_ClearIntCountErr =        27;   //Error while the clear interrupt count
        public const UInt16 PCIELM4_GetSysBufferErr =         28;   //Error while retrieving the system buffer
        public const UInt16 PCIELM4_CreateEventErr =          29;   //Error while create the event
        public const UInt16 PCIELM4_UnSupportedResolution =   30;   //Resolution not supported
        public const UInt16 PCIELM4_CreateThreadErr =         31;   //Error while create the thread
        public const UInt16 PCIELM4_ThreadTimeOutErr =        32;   //Thread timeout error
        public const UInt16 PCIELM4_FIFOOverFlowErr =         33;   //FIFO overflow error
        public const UInt16 PCIELM4_FIFOTimeOutErr =          34;  //FIFO timeout error
        public const UInt16 PCIELM4_GetIntInstStatus =        35;   //Retrieves the status of the interrupt installation
        public const UInt16 PCIELM4_GetBufStatus =            36;   //Retrieves the status of the system buffer
        public const UInt16 PCIELM4_SetBufCountErr =          37;   //Error while setting the buffer count
        public const UInt16 PCIELM4_SetBufInfoErr =           38;   //Error while setting the buffer data
        public const UInt16 PCIELM4_FindCardIDErr =           39;   //Card ID code could not be found
        public const UInt16 PCIELM4_EventThreadErr =          40;   //Event Thread error
        public const UInt16 PCIELM4_AutoCreateEventErr =      41;   //Error while automatically creating an event
        public const UInt16 PCIELM4_RegThreadErr =            42;   //Register Thread error
        public const UInt16 PCIELM4_SearchEventErr =          43;   //Search Event error
        public const UInt16 PCIELM4_FifoResetErr =            44;   //Error while resetting the FIFO
        public const UInt16 PCIELM4_InvalidBlock =            45;   //Invalid EEPROM block
        public const UInt16 PCIELM4_InvalidAddr =             46;   //Invalid EEPROM address
        public const UInt16 PCIELM4_AcqireSpinLock =          47;   //Error while acquiring spin lock
        public const UInt16 PCIELM4_ReleaseSpinLock =         48;   //Error while releasing spin lock
        public const UInt16 PCIELM4_SetControlErr =           49;   //Analog input setting error
        public const UInt16 PCIELM4_InvalidChannels =         50;   //Invalid channel number
        public const UInt16 PCIELM4_SearchCardErr =           51;   //Invalid model number
        public const UInt16 PCIELM4_SetMapAddressErr =        52;   //Error while setting the mapping address
        public const UInt16 PCIELM4_ReleaseMapAddressErr =    53;   //Error while releasing the mapping address
        public const UInt16 PCIELM4_InvalidOffset =           54;   //Invalid memory offset
        public const UInt16 PCIELM4_ShareHandleErr =          55;   //Open the share memory fail
        public const UInt16 PCIELM4_InvalidDataCount =        56;  //Invalid data count
        public const UInt16 PCIELM4_WriteEEPErr =             57;   //Error while writing the EEPROM
        public const UInt16 PCIELM4_CardIOErr =               58;   //CardIO error
        public const UInt16 PCIELM4_IOErr =                   59;   //MemoryIO error
        public const UInt16 PCIELM4_SetScanChannelErr =       60;
        public const UInt16 PCIELM4_SetScanConfigErr =        61;
        public const UInt16 PCIELM4_GetMMIOMapStatus =        62;


        [StructLayout(LayoutKind.Sequential)]
        public struct PCIELM4_DEVICE_INFO
        {
            public UInt32 AdwSize; //Structure Size
            public UInt16 wVendorID; //Vendor ID
            public UInt16 wDeviceID; //Device ID
            public UInt16 wSubVendorID; //Sub Vendor ID
            public UInt16 wSubDeviceID; //Sub Device ID
            // <VBFixedArray(5)> Public dwBAR() As UInt32
            public UInt32 dwBAR0; //PCI Bar 0
            public UInt32 dwBAR1; //PCI Bar 1
            public UInt32 dwBAR2; //PCI Bar 2
            public UInt32 dwBAR3; //PCI Bar 3
            public UInt32 dwBAR4; //PCI Bar 4
            public UInt32 dwBAR5; //PCI Bar 5 
            public byte BusNo;
            public byte DevNo;
            public byte IRQ;
            public byte Aux;
            // <VBFixedArray(5)> Public dwReserved1() As UInt32   'Reserver 
            public UInt32 dwBarVirtualAddress0; // PCI Bar Virtual Address Bar 0(For MMIO) 
            public UInt32 dwBarVirtualAddress1; // PCI Bar Virtual Address Bar 1(For MMIO)
            public UInt32 dwBarVirtualAddress2; // PCI Bar Virtual Address Bar 2(For MMIO) 
            public UInt32 dwBarVirtualAddress3; // PCI Bar Virtual Address Bar 3(For MMIO) 
            public UInt32 dwBarVirtualAddress4; // PCI Bar Virtual Address Bar 4(For MMIO) 
            public UInt32 dwBarVirtualAddress5; // PCI Bar Virtual Address Bar 5(For MMIO) 
            // Sub Initialize()
            //    ReDim dwBAR(5)
            //    ReDim dwReserved1(5)
            //  End Sub
        }

        [StructLayout(LayoutKind.Sequential)]

        public struct PCIELM4_CARD_INFO
        {
            public UInt32 dwSize;       //Structure size
            public UInt32 dwModelNo; // Model Number
    
            //CardID is update when calling the function each time.
            public byte CardID; // for new cards, 0xFF=N/A
            public byte wSingleEnded; // for new cards,1:S.E 2:D.I.F,0xFF=N/A
            public UInt16 wReserved; // Reserver


            public UInt16 wAIChannels; // Number of AI channels(AD)
            public UInt16 wAOChannels; // Number of AO channels(DA)

            public UInt16 wDIPorts; // Number of DI ports
            public UInt16 wDOPorts; // Number of DO ports


            public UInt16 wDIOPorts; // Number of DIO ports
            public UInt16 wDIOPortWidth; // The width is 8/16/32 bit.

            public UInt16 wCounterChannels; // Number of Timers/Counters
            public UInt16 wMomorySize; // PCI-M512==>512, Units in KB.

            public UInt32 dwReserved10; // Reserver 
            public UInt32 dwReserved11; // Reserver
            public UInt32 dwReserved12; // Reserver 
            public UInt32 dwReserved13; // Reserver 
            public UInt32 dwReserved14; // Reserver 
            public UInt32 dwReserved15; // Reserver
        }

        //Driver functions
        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_DriverInit(ref UInt16 wTotalBoards);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_DriverClose();

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_GetCardInfo(UInt16 wBoardNo,ref PCIELM4_DEVICE_INFO sDevInfo, ref PCIELM4_CARD_INFO sCardInfo, [MarshalAs(UnmanagedType.LPArray)]byte[] szModelNmae);

        //Digital I/O function
        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_WriteDO(UInt16 wBoardNo, UInt32 dwDOVal);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_ReadDI(UInt16 wBoardNo, ref UInt32 dwDIVal);

        //Analog Output
        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_ConfigAO(UInt16 wBoardNo, UInt16 wChannel, UInt16 wMode, UInt16 wCfgCode);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_WriteAOVoltage(UInt16 wBoardNo, UInt16 wChannel, float fValue);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_WriteAOVoltageH(UInt16 wBoardNo, UInt16 wChannel, UInt32 hValue);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_StartAOVoltageALL(UInt16 wBoardNo, float fSamplingRate, UInt32 dwDataCount, UInt32 dwCyclyNum, float[] fValueCH0, float[] fValueCH1);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_StartAOVoltageALLH(UInt16 wBoardNo, float fSamplingRate, UInt32 dwDataCount, UInt32 dwCyclyNum, UInt32[] dwValueCH0, UInt32[] dwValueCH1);
        
        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_StopAOALL(UInt16 wBoardNo);

        //Analog Input
        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_ConfigAIAutoZero(UInt16 wBoardNo, UInt16 wChannel, UInt16 wEnableAutoZero);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_SaveAIAutoZeroVal(UInt16 wBoardNo, UInt16 wChannel, UInt32 lSamplingRate,UInt32 dwAutoZeroValue);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_ConfigAI(UInt16 wBoardNo, UInt16 wFIFOSizeKB, UInt32 BufferSizeKB, UInt16 wCardType, UInt16 wDelaySettlingTime, UInt32 dwMode);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_PollingAI(UInt16 wBoardNo, UInt16 wChannel, UInt16 wConfig, UInt32 lSamplingRate, UInt32 dwDataCount, double[] fValue);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_PollingAIH(UInt16 wBoardNo, UInt16 wChannel, UInt16 wConfig, UInt32 lSamplingRate, UInt32 dwDataCount, UInt32[] dwValue);

        [DllImport("PCIELM4.dll")]
        public static extern UInt16 PCIELM4_AIHex2Vol(UInt16 wBoardNo, UInt16 wChannel, UInt16 wConfig, UInt32 dwVal, ref double dVal);


    }

}
